package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;

public class PUTSTATIC extends FieldInstruction implements ExceptionThrower, PopInstruction
{
    PUTSTATIC() {
    }
    
    public PUTSTATIC(final int index) {
        super((short)179, index);
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitExceptionThrower(this);
        v.visitStackConsumer(this);
        v.visitPopInstruction(this);
        v.visitTypedInstruction(this);
        v.visitLoadClass(this);
        v.visitCPInstruction(this);
        v.visitFieldOrMethod(this);
        v.visitFieldInstruction(this);
        v.visitPUTSTATIC(this);
    }
    
    @Override
    public int consumeStack(final ConstantPoolGen cpg) {
        return this.getFieldSize(cpg);
    }
    
    @Override
    public Class<?>[] getExceptions() {
        return ExceptionConst.createExceptions(ExceptionConst.EXCS.EXCS_FIELD_AND_METHOD_RESOLUTION, ExceptionConst.INCOMPATIBLE_CLASS_CHANGE_ERROR);
    }
}
